#ifndef __NLL_FUNCTION_H_INCLUDED__
#define __NLL_FUNCTION_H_INCLUDED__

typedef enum {
  FUNCTION_TYPE_NONE = 0,
  FUNCTION_TYPE_VALUE,
  FUNCTION_TYPE_TRUE,
  FUNCTION_TYPE_FALSE,
  FUNCTION_TYPE_COND,
  FUNCTION_TYPE_AT,
  FUNCTION_TYPE_FPUSH,
  FUNCTION_TYPE_FPOP,
  FUNCTION_TYPE_PUTS,
  FUNCTION_TYPE_INPUT,
  FUNCTION_TYPE_SCREEN,
  FUNCTION_TYPE_SCRCLR,
  FUNCTION_TYPE_GETSCR,
  FUNCTION_TYPE_GETPOS,
  FUNCTION_TYPE_ATTRIBUTE,
  FUNCTION_TYPE_MOVE,
  FUNCTION_TYPE_SCROLL,
  FUNCTION_TYPE_GETCH,
  FUNCTION_TYPE_INKEY,
  FUNCTION_TYPE_ITOA,
  FUNCTION_TYPE_ATOI,
#ifdef NLL_FLOATING_POINT
  FUNCTION_TYPE_ITOF,
  FUNCTION_TYPE_FTOI,
#endif
  FUNCTION_TYPE_LENGTH,
  FUNCTION_TYPE_LEFT,
  FUNCTION_TYPE_RIGHT,
  FUNCTION_TYPE_MID,
  FUNCTION_TYPE_INSTR,
  FUNCTION_TYPE_STRCPY,
  FUNCTION_TYPE_RAND,
  FUNCTION_TYPE_ASCII,
  FUNCTION_TYPE_CHAR,
  FUNCTION_TYPE_INT,
  FUNCTION_TYPE_ABS,
  FUNCTION_TYPE_SIGN,
  FUNCTION_TYPE_TIME,
  FUNCTION_TYPE_DATE,
  FUNCTION_TYPE_MEMORY,
  FUNCTION_TYPE_PEEK,
  FUNCTION_TYPE_POKE,
  FUNCTION_TYPE_READ,
  FUNCTION_TYPE_WRITE,
  FUNCTION_TYPE_MEMCPY,
#ifdef USE_MATHLIB
  FUNCTION_TYPE_PI,
  FUNCTION_TYPE_SIN,
  FUNCTION_TYPE_COS,
  FUNCTION_TYPE_SQR,
#endif
  FUNCTION_TYPE_FOPEN,
  FUNCTION_TYPE_FCLOSE,
  FUNCTION_TYPE_FGETS,
  FUNCTION_TYPE_FPUTS,
  FUNCTION_TYPE_FREAD,
  FUNCTION_TYPE_FWRITE,
} function_type_t;

struct function {
  const char *name;
  char *other_name;
  function_type_t type;
  int retval_number;
  int (*function)(value_t value, value_t args);
};

const char *function_name(function_t function);
int function_search(const char *name, function_t *functionp);
int function_list(FILE *fp);
int function_proc(function_t function, value_t value, value_t args);

#endif
